var Boot = {
	preload: function() {
		//Load images
		//game.load.image('name', 'source');
		game.load.image('weed', 'assets/graphics/weed.png');
	},

	create: function() {
		
		//continue even when out of focus
		game.stage.disableVisibilityChange = true;
		
		//Show as much as possible, remain ratio
			this.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
			game.input.maxPointers = 1;
			if (game.device.desktop)
			{
				game.scale.pageAlignHorizontally = true;
				game.scale.pageAlignVertically = true;
			}
			else
			{
				game.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
				game.scale.minWidth = 480;
				game.scale.minHeight = 260;
				game.scale.maxWidth = 1024;
				game.scale.maxHeight = 768;
				game.scale.forceLandscape = true;
				game.scale.pageAlignHorizontally = true;
				game.scale.pageAlignVertically = true;
				game.scale.setScreenSize(true);
			}
		
		game.state.start('Loading');
	},

};

var Loading = {
	preload: function() {
		var weedLogo = game.add.sprite(game.world.centerX,game.world.centerY, 'weed');
		weedLogo.anchor.setTo(0.5,0.5);
		this.load.setPreloadSprite(weedLogo);
		
		//Load images
		game.load.image('dollar', 'assets/graphics/dollar.png');
		game.load.image('weedSell', 'assets/graphics/weedSell.png');
		game.load.image('weedplant', 'assets/graphics/weedplant.png');
		game.load.image('waterCanIcon', 'assets/graphics/waterCanIcon.png');
		game.load.image('workers', 'assets/graphics/gloves.png');
		game.load.image('save', 'assets/graphics/save.png');
		game.load.image('load', 'assets/graphics/load.png');
		game.load.image('reload', 'assets/graphics/reload.png');
		game.load.image('speaker', 'assets/graphics/speaker.png');
		game.load.image('book', 'assets/graphics/book.png');
		game.load.image('fert', 'assets/graphics/fert.png');
		game.load.image('glasshouse', 'assets/graphics/glasshouse.png');
		game.load.image('glassHouseGame', 'assets/graphics/glassHouseGame.png');
		game.load.image('lamp', 'assets/graphics/lamp.png');
		game.load.image('lampGame', 'assets/graphics/lampGame.png');
		game.load.image('seller', 'assets/graphics/seller.png');
		game.load.image('security', 'assets/graphics/security.png');
		game.load.image('lawyer', 'assets/graphics/lawyer.png');

		
		//load spritesheets
		game.load.spritesheet('canAnimation', 'assets/graphics/canAnimation.png', 50, 60);
		game.load.spritesheet('plantA', 'assets/graphics/plantASprite.png', 100, 68);
		game.load.spritesheet('workerA', 'assets/graphics/workerASprite.png', 100, 68);
		game.load.spritesheet('clickerA', 'assets/graphics/clickerASprite.png', 100, 68);
		game.load.spritesheet('sellerA', 'assets/graphics/sellerASprite.png', 100, 68);
		game.load.spritesheet('weedA', 'assets/graphics/weedASprite.png', 100, 68);
		
		//load music
		game.load.audio('background', ['assets/sounds/background.mp3', 'assets/sounds/background.ogg']);
		
	},

	create: function() {
		var nameText = "Growing Weed";
		var title = game.add.text(game.world.centerX,game.world.centerY - 300, nameText, {
			font: "68px Arial",
			fill: "#FFFFFF",
			align: "center"
		});
		title.anchor.setTo(0.5);

	
		var discText = "DISCLAIMER \n I do not support drugs! \nDO NOT PLANT, SELL OR USE WEED! It's probably illegal where you live. \n Game is just for fun.";
		var disclaimer = game.add.text(game.world.centerX,game.world.centerY + 300, discText, {
			font: "12px Arial",
			fill: "#FFFFFF",
			align: "center"
		});
		disclaimer.anchor.setTo(0.5);
		
		
		//Start game after 5 seconds
		game.time.events.loop(5000, function() {
			game.state.start('MainGame');
		});		
		
	},

};

function ReloadGame()
{
	game.state.start('MainGame');
	mute();
}


var moneyText;
var money;
var plants;
var weed;
var weedRate;
var weedClick;
var pricePerWeed;
var sellButton;
var waterCan;
var workers;
var counter;

var sellers;
var security;
var lawyers;

//achievements
var weedClicked;
var weedMax;
var weedSoldMax;

//var toolTipText;
var myText;

var plantArray;
var upgradeButtonsData;
var upgradeButtons;
var reloadButton;
var muteButton;
var plantButton;

var music;


var MainGame = {
	preload: function () {
		money = 1000;
		plants = 0;
		weed = 0;
		weedRate = 0.001;
		weedClick = 0.01;
		pricePerWeed = 100;
		waterCan = 0;
		workers = 0;
		counter = 0;
		weedClicked = 0;
		weedMax = 0;
		weedSoldMax = 0;
		plantArray = [];
		sellers = 0;
		security = 0;
		lawyers = 0;
		
		//LoadGame();
		
		//topbar
		var topbar = this.game.add.bitmapData(1024, 40);
		topbar.ctx.fillStyle = '#9a783d';
		topbar.ctx.fillRect(0, 0, 1024, 40);
		this.game.cache.addBitmapData('topbar', topbar);
		
		//achievement area with board to display trophies
		var achievArea = this.game.add.bitmapData(500, 80);
		achievArea.ctx.fillStyle = '#FFFFFF';
		achievArea.ctx.lineWidth = 12;
		achievArea.ctx.fillRect(0,0, 500, 80);
		achievArea.ctx.strokeStyle = '#35371c';
		achievArea.ctx.beginPath(); 
		achievArea.ctx.moveTo(0,80);
		achievArea.ctx.lineTo(500, 80);
		achievArea.ctx.stroke();
		this.game.cache.addBitmapData('achievArea', achievArea);
		
		//upgrade area
		var bmd = this.game.add.bitmapData(1024, 164);
		bmd.ctx.fillStyle = '#9a783d';
		bmd.ctx.strokeStyle = '#35371c';
		bmd.ctx.lineWidth = 12;
		bmd.ctx.fillRect(0, 0, 1024, 164);
		bmd.ctx.strokeRect(0, 0, 1024, 164);
		this.game.cache.addBitmapData('upgradeArea', bmd);
		
		//rectangle button
		var buttonImage = this.game.add.bitmapData(250, 48);
		buttonImage.ctx.fillStyle = '#e6dec7';
		buttonImage.ctx.strokeStyle = '#35371c';
		buttonImage.ctx.lineWidth = 4;
		buttonImage.ctx.fillRect(0, 0, 250, 48);
		buttonImage.ctx.strokeRect(0, 0, 250, 48);
		this.game.cache.addBitmapData('button', buttonImage);
		
		//square button
		var buttonSquare = this.game.add.bitmapData(36, 36);
		buttonSquare.ctx.fillStyle = '#e6dec7';
		buttonSquare.ctx.strokeStyle = '#35371c';
		buttonSquare.ctx.lineWidth = 4;
		buttonSquare.ctx.fillRect(0, 0, 36, 36);
		buttonSquare.ctx.strokeRect(0, 0, 36, 36);
		this.game.cache.addBitmapData('buttonSquare', buttonSquare);
	},

	create: function () {
		
		game.stage.backgroundColor = '#FFFFFF';
		
		//buy plant Button
		
		plantButton = this.game.add.button(10, 50, this.game.cache.getBitmapData('button'));
		plantButton.icon = plantButton.addChild(this.game.add.image(24, 24, 'weed'));
		plantButton.icon.scale.setTo(0.1);
		plantButton.icon.anchor.setTo(0.5,0.5);
		plantButton.text = plantButton.addChild(this.game.add.text(42, 6, 'Buy Plant (' + plants + ')', {font: '16px Arial Black'}));
		plantButton.details = {cost: 10};
		plantButton.costText = plantButton.addChild(this.game.add.text(42, 24, 'Cost: ' + plantButton.details.cost, {font: '16px Arial Black'}));
		plantButton.events.onInputDown.add(this.plantWeed, this);
				
		//sell weed Button 
		sellButton = this.game.add.button(10, 105, this.game.cache.getBitmapData('button'));
		sellButton.icon = sellButton.addChild(this.game.add.image(24, 24, 'weedSell'));
		sellButton.icon.anchor.setTo(0.5,0.5);
		sellButton.details = {prize: 100, count: 0};
		sellButton.text = sellButton.addChild(this.game.add.text(42, 6, 'Sell weed (' + sellButton.details.count + ' g)', {font: '16px Arial Black'}));
		sellButton.costText = sellButton.addChild(this.game.add.text(42, 24, 'Price: ' + pricePerWeed + '/g', {font: '16px Arial Black'}));
		sellButton.events.onInputDown.add(sellWeed, this);
		
		//display money
		this.topbar = this.game.add.image(0, 0, this.game.cache.getBitmapData('topbar'));
		moneySign = game.add.sprite(0,0, 'dollar');
		moneyText = game.add.text(20, 5, money, {
			font: "24px Arial",
			fill: "#FFFFFF",
			align: "center"
		});
		
		//empty text in topbar
		myText = game.add.text(game.world.centerX, 20, "", {
			font: "18px Arial",
			fill: "#000000",
			align: "center"
		});
		
		//display achievement area
		this.achievArea = this.game.add.image(500, 80, this.game.cache.getBitmapData('achievArea'));
		
		//display upgrade area
		this.upgradePanel = this.game.add.image(0, 604, this.game.cache.getBitmapData('upgradeArea'));
		upgradeButtons = this.upgradePanel.addChild(this.game.add.group());
		upgradeButtons.position.setTo(8, 8);
		
		
		
		
		//upgrades
        upgradeButtonsData = [
            {isHidden: false, icon: 'waterCanIcon', name: 'Water Can', level: 0, cost: 50, purchaseHandler: function(button) {
				waterCan ++;
				if(plantArray.length >= waterCan && waterCan < 10){
					var can = game.add.sprite((waterCan) * 100 -10 , 230,'canAnimation');
					can.anchor.setTo(0.5);
					can.animations.add('water', [0, 1, 2, 3, 4], 5, false);
					game.time.events.loop(6000, function() {
						can.animations.play('water');
					});				
					for(var i = 0; i < plantArray.length; i++)
					{
						if(plantArray[i].water === false)
						{
							plantArray[i].water = true;	
							break;
						}					
					}				
				}		
            }},
			//Workers, increase weed earned per second
			{isHidden: false, icon: 'workers', name: 'Workers', level: 0, cost: 200, purchaseHandler: function(button) {
				workers ++;
            }},
			//Gardening books, unlock more updates
			{isHidden: false, icon: 'book', name: 'Gardening Books', level: 0, cost: 400, purchaseHandler: function(button) {
				for(var i = 0; i < upgradeButtonsData.length; i++)
				{
					if(upgradeButtonsData[i].isHidden === true)
					{
						upgradeButtonsData[i].isHidden = false;	
						break;
					}
						
				}
            }},
			//Fertilizer, increases weed earned by clicking
			{isHidden: true, icon: 'fert', name: 'Fertilizer', level: 0, cost: 600, purchaseHandler: function(button) {
				weedClick += (0.2*upgradeButtonsData[3].level);
				weedRate *= 1;
            }},
			//Small Glasshouses, increases weed rate
			{isHidden: true, icon: 'glasshouse', name: 'Glass houses', level: 0, cost: 1200, purchaseHandler: function(button) {
				level = upgradeButtonsData[4].level;
				weedClick += (0.3*level);
				weedRate *= 1.2;
				
				if(plantArray.length/9 >= level && level < 2){
					var light = game.add.sprite(16, 240,'glassHouseGame');
					light.scale.setTo(1.1);		
				}	
				
            }},
			//Lights, increases weed rate
			{isHidden: true, icon: 'lamp', name: 'Light Systems', level: 0, cost: 800, purchaseHandler: function(button) {
				level = upgradeButtonsData[5].level;
				weedClick += (0.4*level);
				weedRate *= 1.4;
				
				if(plantArray.length/3 >= level && level < 4){
					var light = game.add.sprite((level * 330) - 150, 185,'lampGame');
					light.anchor.setTo(0.5);
					light.scale.setTo(0.9);			
				}	

				upgradeButtonsData[6].isHidden = false;
				upgradeButtonsData[7].isHidden = false;
				upgradeButtonsData[8].isHidden = false;
				
				
            }},
			//each seller sells every 1 minute
			{isHidden: true, icon: 'seller', name: 'Sellers', level: 0, cost: 2000, purchaseHandler: function(button) {
				level = upgradeButtonsData[6].level;
				sellers += 1;	
				
				game.time.events.loop(60000, function() {
					randomPoliceEvent();
					sellWeed();									
				});
									
            }},
			{isHidden: true, icon: 'security', name: 'Security', level: 0, cost: 4000, purchaseHandler: function(button) {
				level = upgradeButtonsData[7].level;
				security += 1;	
				
									
            }},
			{isHidden: true, icon: 'lawyer', name: 'Lawyers', level: 0, cost: 8000, purchaseHandler: function(button) {
				level = upgradeButtonsData[8].level;
				lawyers += 1;	
									
            }},
        ];
		
		
		//achievements
		achievementsData = [
			{icon: 'plantA', name: 'plants', depend: 'plants', first: 10, firstFlag: false, second: 50, secondFlag: false, third: 100, thirdFlag: false},
			{icon: 'workerA', name: 'workers', depend: 'workers', first: 10, firstFlag: false, second: 50, secondFlag: false, third: 100, thirdFlag: false},
			{icon: 'clickerA', name: 'clicks', depend: 'weedClicked', first: 100, firstFlag: false, second: 500, secondFlag: false, third: 1000, thirdFlag: false},
			{icon: 'sellerA', name: 'weedSoldMax', depend: 'weedSoldMax', first: 100, firstFlag: false, second: 500, secondFlag: false, third: 1000, thirdFlag: false},
			{icon: 'weedA', name: 'weedMax', depend: 'weedMax', first: 1000, firstFlag: false, second: 5000, secondFlag: false, third: 10000, thirdFlag: false},			
		];
		
		
		//update buttons and achievements every second
		game.time.events.loop(1000, function() {
			MainGame.UpdateButtons();
			MainGame.UpdateAchiev();
			MainGame.calculateWeed();
		});
		
		//change weed price every 10 seconds
		game.time.events.loop(10000, function() {
			pricePerWeed = Math.floor(Math.random()* (150 - 50) + 50);
			sellButton.costText.text = 'Price: ' + pricePerWeed + '/g';			
		});		
		
	},

	
	onUpgradeButtonClick: function(button, pointer) 
	{
        // update new price
        function getAdjustedCost() 
		{
			return Math.ceil(button.details.cost * 1.3);
        }
		
		//Check for conditions
		if(button.details.name == 'Water Can')
		{
			if(button.details.level >= plants)
			{
				movingText('You don\'t need more cans than plants!');
				return;
			}
		}
		else if(button.details.name == 'Gardening Books')
		{
			if(button.details.level >= 3)
			{
				movingText('You know everything books could teach you!');
				return;
			}
		}
		else if(button.details.name == 'Fertilizer')
		{
			if(button.details.level >= (plants * 3))
			{
				movingText('You don\'t need that much fertilizer for your plants!');
				return;
			}
		}
		else if(button.details.name == 'Glass houses')
		{
			if(plants < ((button.details.level +1) * 9))
			{
				movingText('One glass house is big enough for nine plants!');
				return;
			}

		}
		else if(button.details.name == 'Light Systems')
		{
			if(plants < ((button.details.level +1) * 3))
			{
				movingText('One light should be used for no less than three plants!');
				return;
			}
		}
		
		var cost = button.details.cost;
        if (money >= cost) 
		{
            updateMoney(-cost);
            button.details.level++;
            button.text.text = button.details.name + ': ' + button.details.level;
			button.details.cost = getAdjustedCost();
            button.details.purchaseHandler.call();
        }
		else
			movingText('You don\'t have enough money to do that');
    },
	
	//update button visibility and text
	UpdateButtons: function()
	{
		var button;
		upgradeButtonsData.forEach(function(buttonData, index) {
			if(index <= 2)
			{
				button = this.game.add.button(0, (50 * index), game.cache.getBitmapData('button'));
			}
			else if(2 < index && index <= 5)
			{
				button = this.game.add.button(255, (50 * (index%3)), game.cache.getBitmapData('button'));
			}
			else if(4 < index && index <= 8)
			{
				button = this.game.add.button(510, (50 * (index%3)), game.cache.getBitmapData('button'));
			}
            button.icon = button.addChild(game.add.image(6, 6, buttonData.icon));
            button.text = button.addChild(game.add.text(60, 6, buttonData.name + ': ' + buttonData.level, {font: '16px Arial Black'}));
            button.details = buttonData;
            button.costText = button.addChild(game.add.text(60, 24, 'Cost: ' + buttonData.cost, {font: '16px Arial Black'}));
			button.events.onInputDown.add(MainGame.onUpgradeButtonClick, this);
            upgradeButtons.addChild(button);
			
			if(buttonData.isHidden === true)
			{
				button.visible = false;
			}
			else if(buttonData.isHidden === false)
			{
				button.visible = true;
			}

        });
	},

	//update achievments
	UpdateAchiev: function()
	{
		var achiev;
		
		achievementsData.forEach(function(achievData, index) {
			
			achiev = game.add.sprite(500 +(100 * index), 90, achievData.icon);
			achiev.details = achievData;
			
			
			if(this[achievData.depend] >= achievData.third)
			{
				achiev.frame = 2;
				achievData.firstFlag = true;
				achiev.visbible = true;
			}
			else if(this[achievData.depend] >= achievData.second)
			{
				achiev.frame = 1;
				achievData.firstFlag = true;
				achiev.visbible = true;
			}
			else if(this[achievData.depend] >= achievData.first)
			{
				achiev.frame = 0;
				achievData.firstFlag = true;
				achiev.visbible = true;
			}
			
			else
			{
				achiev.visible = false;
			}

        });
	},
	
	
	//buy a plant 
	plantWeed: function(button, pointer)
	{	
		var plant = [];
		var cost = button.details.cost;	
		if(money > cost)
		{
			
			plant = {water: false};
			plantArray.push(plant);
			plants = plantArray.length;
			if(plants <= 9){
				
				plant[plants-1] = game.add.sprite((plants - 1) * 100, 150, 'weedplant');
				plant[plants-1].inputEnabled = true;
				plant[plants-1].id = counter;
				plant[plants-1].events.onInputDown.add(MainGame.plantClicked, this);
				counter ++;
			}
			//add save button after first plant
			if (plants == 1)
			{
				//reload Button;
				reloadButton = MainGame.game.add.button(985, 2, this.game.cache.getBitmapData('buttonSquare'),ReloadGame);
				reloadButton.icon = reloadButton.addChild(game.add.image(18, 18, 'reload'));
				reloadButton.icon.anchor.setTo(0.5,0.5);
				reloadButton.icon.scale.setTo(0.7);

			}
			
			//start reggae music if the 9th plant is bought
			if (plants == 9)
			{
				music = game.add.audio('background');
				music.volume = 0.2;
				music.loopFull();
				
				//mute Button 
				muteButton = this.game.add.button(945, 2, this.game.cache.getBitmapData('buttonSquare'), mute);
				muteButton.icon = muteButton.addChild(game.add.image(18, 18, 'speaker'));
				muteButton.icon.anchor.setTo(0.5,0.5);
				muteButton.icon.scale.setTo(0.7);

			}
			
			updateMoney(-cost);
			cost = Math.ceil(cost + (plants * 1.46));
			button.details.cost = cost;
			button.costText.text = 'Cost: ' + cost;
			button.text.setText('Buy Plant (' + plants + ')');
		}
		
	},
	
	//pick plants by clicking
	plantClicked: function(plant)
	{
		if(plantArray[plant.id].water)
		{
			weed += (weedClick * 3);
			weedMax += (weedClick * 3);
		}
		else
		{
			weed += weedClick;
			weedMax += weedClick;
		}
		weedClicked += 1;
		
		MainGame.UpdateButtons();
		weed = prettify(weed);
		sellButton.details.count = weed;
		sellButton.text.text = 'Sell weed (' + sellButton.details.count + ' g)';
		
	},
	
	//calculates Weed per second
	calculateWeed: function (){
			weed += plants * (weedRate * workers);
			weed = prettify(weed);
			weedMax += plants * (weedRate * workers);
			weedMax = prettify(weed);
			sellButton.details.count = weed;
			sellButton.text.text = 'Sell weed (' + sellButton.details.count + ' g)';
	}
		
};

function sellWeed(){
	
	var win;
	
	if(weed > 0)
	{
		win = weed * pricePerWeed;
		win = prettify(win);
		updateMoney(win);
		weedSoldMax += weed; //achievement
		movingText('You sold ' + weed +'g of weed for ' + win + '$.');
		weed = 0;
		sellButton.text.text = 'Sell weed (' + weed + ' g)';
	}
	
}

function updateMoney(value){	
	money += value;
	money = prettify(money);
	moneyText.setText(money);
	
}

function randomPoliceEvent()
{
	PoliceEvent = Math.floor((Math.random()*2)+1);
	
	if(PoliceEvent == 1)
	{
		if(plants > 9){
			if((security +1) * 10 < plants)
			{
				plants = (security+1)*10;
				weed = 0;
				plantButton.text.text = 'Buy Plant (' + plants + ')';
				sellButton.text.text = 'Sell weed (' + weed + ' g)';
				movingText('There was a police raid. Your plants and weed were confiscated. Invest in Security!');
			}
			else
			{
				movingText('There was a police raid. Thanks to your securiy nothing happened.');
			}
		}
		
	}
	else if(PoliceEvent == 2)
	{
		if(sellers > 0){
			if(lawyers * 10 < sellers)
			{
				money -= sellers * 500;
				upgradeButtonsData[6].level = 0;
				sellers = 0;
				movingText('The police cought your dealers. You paid their bail but they guit! Invest in Lawyers.');
			}
			else
			{
				movingText('The police cought your dealers. Your lawyers got them out!');
			}
		}
	}
	
}

//
//Helper functions
//

//mute music
function mute()
{
	music.mute = !music.mute;
}

//display text in topbar
function movingText(textToMove){
	
	myText.text = '';
	
	myText.text = textToMove;
	
	myText.anchor.setTo(0.5);
	game.time.events.add(2000, function() {
		myText.text = '';
	}, this);
	
}

//smaller numbers
function prettify(input){
    var output = Math.round(input * 1000000)/1000000;
	return output;
}



//initialize game
var game = new Phaser.Game(1024, 768, Phaser.AUTO);

game.state.add('Boot', Boot);
game.state.add('Loading', Loading);
game.state.add('MainGame', MainGame);

//launch game
game.state.start('Boot');



//
//Tooltip
//


/*
//Add tooltip on hover
plantButton.hoverText = "Click to buy plant";
plantButton.events.onInputOver.add(this.tooltip, this);
plantButton.events.onInputOut.add(this.tooltipOff, this);
		
tooltip: function(item)
	{
		textToMove = item.hoverText;
		
		toolTipText = game.add.text(game.input.mousePointer.x + 20, game.input.mousePointer.y, textToMove, {
			font: "18px Arial",
			fill: "#000000",
			align: "center"
		});
		//toolTipText.anchor.setTo(0.5);
		//game.time.events.add(2000, function() {
		//game.add.tween(myText).to({alpha: 0}, 200, Phaser.Easing.Linear.None, true);
		//}, this);
	},
	
	tooltipOff: function(item)
	{
		
		toolTipText.visible = false;
		
	},
*/


//
//Saving & Loading
//
/*
function SaveGame(){
		
	var saveObject = {
	sMoney: money,
	sPlants: plants,
	sWeed: weed,
	sWaterCan: waterCan,
	sWorkers: workers,
	//sPlantArray: plantArray,
	};

	// localStorage only works with strings, so JSON.stringify first.
	localStorage.setItem("saveLD34", JSON.stringify(saveObject));
	//console.log(saveObject);
	movingText('Game was saved');
	
}

function LoadGame(){
	money = 1000;
	plants = 0;
	weed = 0;
	weedRate = 0.001;
	weedClick = 0.01;
	pricePerWeed = 100;
	waterCan = 0;
	workers = 0;
	counter = 0;
	weedClicked = 0;
	weedMax = 0;
	weedSoldMax = 0;
	plantArray = [];
	sellers = 0;
	
	
	var savegame = localStorage.getItem("saveLD34");
	console.log(savegame);
	
	if (savegame !== null){
		if (typeof savegame.sMoney !== "undefined") money = savegame.sMoney;
		if (typeof savegame.sPlants !== "undefined") plants = savegame.sPlants;
		if (typeof savegame.sWeed !== "undefined") weed = savegame.sWeed;
		if (typeof savegame.sWaterCan !== "undefined") waterCan = savegame.sWaterCan;
		if (typeof savegame.sWorkers !== "undefined") workers = savegame.sWorkers;
		if (typeof savegame.sPlantArray !== "undefined") plantArray = savegame.sPlantArray;
	
	}

}

		//load Button;
		/*var loadButton;
		loadButton = this.game.add.button(985, 2, this.game.cache.getBitmapData('buttonSquare'),ReloadGame);
		loadButton.icon = loadButton.addChild(game.add.image(18, 18, 'reload'));
		loadButton.icon.anchor.setTo(0.5,0.5);
		loadButton.icon.scale.setTo(0.7);
		

*/